Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/XMP.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/XMP.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/XMP.pm	(revision 34921)
@@ -1805,28 +2110,60 @@
         },
     },
+    GPSHPositioningError => { #12
+        Description => 'GPS Horizontal Positioning Error',
+        Groups => { 2 => 'Location' },
+        Writable => 'rational',
+        PrintConv => '"$val m"',
+        PrintConvInv => '$val=~s/\s*m$//; $val',
+    },
     NativeDigest => { }, #PH
-);
-
-# Auxiliary schema properties (aux) - not fully documented (ref PH)
-%Image::ExifTool::XMP::aux = (
+    # new Exif
+);
+
+# Exif extended properties (exifEX, ref 12)
+%Image::ExifTool::XMP::exifEX = (
     %xmpTableDefaults,
-    GROUPS => { 1 => 'XMP-aux', 2 => 'Camera' },
-    NAMESPACE   => 'aux',
-    NOTES => 'Photoshop Auxiliary schema tags.',
-    Firmware        => { }, #7
-    FlashCompensation => { Writable => 'rational' }, #7
-    ImageNumber     => { }, #7
-    LensInfo        => { #7
-        Notes => '4 rational values giving focal and aperture ranges',
-        # convert to floating point values (or 'inf' or 'undef')
-        ValueConv => sub {
-            my $val = shift;
-            my @vals = split ' ', $val;
-            return $val unless @vals == 4;
-            foreach (@vals) {
-                ConvertRational($_) or return $val;
-            }
-            return join ' ', @vals;
-        },
+    GROUPS => { 1 => 'XMP-exifEX', 2 => 'Image' },
+    NAMESPACE   => 'exifEX',
+    PRIORITY => 0, # not as reliable as actual EXIF tags
+    NOTES => q{
+        EXIF tags added by the EXIF 2.31 for XMP specification (see
+        L<http://www.cipa.jp/std/documents/e/DC-X010-2017.pdf>).
+    },
+    Gamma                       => { Writable => 'rational' },
+    PhotographicSensitivity     => { Writable => 'integer' },
+    SensitivityType => {
+        Writable => 'integer',
+        PrintConv => {
+            0 => 'Unknown',
+            1 => 'Standard Output Sensitivity',
+            2 => 'Recommended Exposure Index',
+            3 => 'ISO Speed',
+            4 => 'Standard Output Sensitivity and Recommended Exposure Index',
+            5 => 'Standard Output Sensitivity and ISO Speed',
+            6 => 'Recommended Exposure Index and ISO Speed',
+            7 => 'Standard Output Sensitivity, Recommended Exposure Index and ISO Speed',
+        },
+    },
+    StandardOutputSensitivity   => { Writable => 'integer' },
+    RecommendedExposureIndex    => { Writable => 'integer' },
+    ISOSpeed                    => { Writable => 'integer' },
+    ISOSpeedLatitudeyyy => {
+        Description => 'ISO Speed Latitude yyy',
+        Writable => 'integer',
+    },
+    ISOSpeedLatitudezzz => {
+        Description => 'ISO Speed Latitude zzz',
+        Writable => 'integer',
+    },
+    CameraOwnerName     => { Name => 'OwnerName' },
+    BodySerialNumber    => { Name => 'SerialNumber', Groups => { 2 => 'Camera' } },
+    LensSpecification => {
+        Name => 'LensInfo',
+        Writable => 'rational',
+        Groups => { 2 => 'Camera' },
+        List => 'Seq',
+        RawJoin => 1, # join list into a string before ValueConv
+        ValueConv => \&ConvertRationalList,
         ValueConvInv => sub {
             my $val = shift;
@@ -1840,5 +2177,95 @@
                 $_ = join '/', @a;
             }
-            return join ' ', @vals;
+            return \@vals; # return list reference (List-type tag)
+        },
+        PrintConv => \&Image::ExifTool::Exif::PrintLensInfo,
+        PrintConvInv => \&Image::ExifTool::Exif::ConvertLensInfo,
+        Notes => q{
+            unfortunately the EXIF 2.3 for XMP specification defined this new tag
+            instead of using the existing XMP-aux:LensInfo
+        },
+    },
+    LensMake            => { Groups => { 2 => 'Camera' } },
+    LensModel           => { Groups => { 2 => 'Camera' } },
+    LensSerialNumber    => { Groups => { 2 => 'Camera' } },
+    InteroperabilityIndex => {
+        Name => 'InteropIndex',
+        Description => 'Interoperability Index',
+        PrintConv => {
+            R98 => 'R98 - DCF basic file (sRGB)',
+            R03 => 'R03 - DCF option file (Adobe RGB)',
+            THM => 'THM - DCF thumbnail file',
+        },
+    },
+    # new in Exif 2.31
+    Temperature         => { Writable => 'rational', Name => 'AmbientTemperature' },
+    Humidity            => { Writable => 'rational' },
+    Pressure            => { Writable => 'rational' },
+    WaterDepth          => { Writable => 'rational' },
+    Acceleration        => { Writable => 'rational' },
+    CameraElevationAngle=> { Writable => 'rational' },
+    # new in Exif 2.32 (according to the spec, these should use a different namespace
+    # URI, but the same namespace prefix... Exactly how is that supposed to work?!!
+    # -- I'll just stick with the same URI)
+    CompositeImage => { Writable => 'integer',
+        PrintConv => {
+            0 => 'Unknown',
+            1 => 'Not a Composite Image',
+            2 => 'General Composite Image',
+            3 => 'Composite Image Captured While Shooting',
+        },
+    },
+    CompositeImageCount => { List => 'Seq', Writable => 'integer' },
+    CompositeImageExposureTimes => {
+        FlatName => 'CompImage',
+        Struct => {
+            STRUCT_NAME => 'CompImageExp',
+            NAMESPACE => 'exifEX',
+            TotalExposurePeriod     => { Writable => 'rational' },
+            SumOfExposureTimesOfAll => { Writable => 'rational', FlatName => 'SumExposureAll' },
+            SumOfExposureTimesOfUsed=> { Writable => 'rational', FlatName => 'SumExposureUsed' },
+            MaxExposureTimesOfAll   => { Writable => 'rational', FlatName => 'MaxExposureAll' },
+            MaxExposureTimesOfUsed  => { Writable => 'rational', FlatName => 'MaxExposureUsed' },
+            MinExposureTimesOfAll   => { Writable => 'rational', FlatName => 'MinExposureAll'  },
+            MinExposureTimesOfUsed  => { Writable => 'rational', FlatName => 'MinExposureUsed' },
+            NumberOfSequences       => { Writable => 'integer',  FlatName => 'NumSequences' },
+            NumberOfImagesInSequences=>{ Writable => 'integer',  FlatName => 'ImagesPerSequence' },
+            Values =>   { List => 'Seq', Writable => 'rational' },
+        },
+    },
+);
+
+# Auxiliary namespace properties (aux) - not fully documented (ref PH)
+%Image::ExifTool::XMP::aux = (
+    %xmpTableDefaults,
+    GROUPS => { 1 => 'XMP-aux', 2 => 'Camera' },
+    NAMESPACE   => 'aux',
+    NOTES => q{
+        Adobe-defined auxiliary EXIF tags.  This namespace existed in the XMP
+        specification until it was dropped in 2012, presumably due to the
+        introduction of the EXIF 2.3 for XMP specification and the exifEX namespace
+        at this time.  For this reason, tags below with equivalents in the
+        L<exifEX namespace|/XMP exifEX Tags> are avoided when writing.
+    },
+    Firmware        => { }, #7
+    FlashCompensation => { Writable => 'rational' }, #7
+    ImageNumber     => { }, #7
+    LensInfo        => { #7
+        Notes => '4 rational values giving focal and aperture ranges',
+        Avoid => 1,
+        # convert to floating point values (or 'inf' or 'undef')
+        ValueConv => \&ConvertRationalList,
+        ValueConvInv => sub {
+            my $val = shift;
+            my @vals = split ' ', $val;
+            return $val unless @vals == 4;
+            foreach (@vals) {
+                $_ eq 'inf' and $_ = '1/0', next;
+                $_ eq 'undef' and $_ = '0/0', next;
+                Image::ExifTool::IsFloat($_) or return $val;
+                my @a = Image::ExifTool::Rationalize($_);
+                $_ = join '/', @a;
+            }
+            return join ' ', @vals; # return string (string tag)
         },
         # convert to the form "12-20mm f/3.8-4.5" or "50mm f/1.4"
@@ -1847,6 +2274,7 @@
     },
     Lens            => { },
-    OwnerName       => { }, #7
-    SerialNumber    => { },
+    OwnerName       => { Avoid => 1 }, #7
+    SerialNumber    => { Avoid => 1 },
+    LensSerialNumber=> { Avoid => 1 },
     LensID          => {
         Priority => 0,
@@ -1858,7 +2286,14 @@
     },
     ApproximateFocusDistance => { Writable => 'rational' }, #PH (LR3)
-);
-
-# IPTC Core schema properties (Iptc4xmpCore) (ref 4)
+    # the following new in LR6 (ref forum6497)
+    IsMergedPanorama         => { Writable => 'boolean' },
+    IsMergedHDR              => { Writable => 'boolean' },
+    DistortionCorrectionAlreadyApplied  => { Writable => 'boolean' },
+    VignetteCorrectionAlreadyApplied    => { Writable => 'boolean' },
+    LateralChromaticAberrationCorrectionAlreadyApplied => { Writable => 'boolean' },
+    LensDistortInfo => { }, # (LR 7.5.1, 4 signed rational values)
+);
+
+# IPTC Core namespace properties (Iptc4xmpCore) (ref 4)
 %Image::ExifTool::XMP::iptcCore = (
     %xmpTableDefaults,
@@ -1867,7 +2302,7 @@
     TABLE_DESC => 'XMP IPTC Core',
     NOTES => q{
-        IPTC Core schema tags.  The actual IPTC Core namespace prefix is
+        IPTC Core namespace tags.  The actual IPTC Core namespace prefix is
         "Iptc4xmpCore", which is the prefix recorded in the file, but ExifTool
-        shortens this for the "XMP-iptcCore" family 1 group name. (see
+        shortens this for the family 1 group name. (see
         L<http://www.iptc.org/IPTC4XMP/>)
     },
@@ -1899,79 +2334,8 @@
     Scene               => { Groups => { 2 => 'Other' }, List => 'Bag' },
     SubjectCode         => { Groups => { 2 => 'Other' }, List => 'Bag' },
-);
-
-# IPTC Extension schema properties (Iptc4xmpExt) (ref 4)
-%Image::ExifTool::XMP::iptcExt = (
-    %xmpTableDefaults,
-    GROUPS => { 1 => 'XMP-iptcExt', 2 => 'Author' },
-    NAMESPACE   => 'Iptc4xmpExt',
-    TABLE_DESC => 'XMP IPTC Extension',
-    NOTES => q{
-        IPTC Extension schema tags.  The actual namespace prefix is "Iptc4xmpExt",
-        but ExifTool shortens this for the "XMP-iptcExt" family 1 group name.
-        (see L<http://www.iptc.org/IPTC4XMP/>)
-    },
-    AddlModelInfo   => { Name => 'AdditionalModelInformation' },
-    ArtworkOrObject => {
-        Struct => {
-            STRUCT_NAME => 'ArtworkOrObjectDetails',
-            NAMESPACE   => 'Iptc4xmpExt',
-            AOCopyrightNotice => { },
-            AOCreator    => { List => 'Seq' },
-            AODateCreated=> { Groups => { 2 => 'Time' }, %dateTimeInfo },
-            AOSource     => { },
-            AOSourceInvNo=> { },
-            AOTitle      => { Writable => 'lang-alt' },
-        },
-        List => 'Bag',
-    },
-    ArtworkOrObjectAOCopyrightNotice=> { Flat => 1, Name => 'ArtworkCopyrightNotice' },
-    ArtworkOrObjectAOCreator        => { Flat => 1, Name => 'ArtworkCreator' },
-    ArtworkOrObjectAODateCreated    => { Flat => 1, Name => 'ArtworkDateCreated' },
-    ArtworkOrObjectAOSource         => { Flat => 1, Name => 'ArtworkSource' },
-    ArtworkOrObjectAOSourceInvNo    => { Flat => 1, Name => 'ArtworkSourceInventoryNo' },
-    ArtworkOrObjectAOTitle          => { Flat => 1, Name => 'ArtworkTitle' },
-    OrganisationInImageCode => { List => 'Bag' },
-    CVterm => {
-        Name => 'ControlledVocabularyTerm',
-        List => 'Bag',
-    },
-    LocationShown => {
-        Struct => \%sLocationDetails,
-        Groups => { 2 => 'Location' },
-        List => 'Bag',
-    },
-    ModelAge                => { List => 'Bag', Writable => 'integer' },
-    OrganisationInImageName => { List => 'Bag' },
-    PersonInImage           => { List => 'Bag' },
-    DigImageGUID            => { Name => 'DigitalImageGUID' },
-    DigitalSourcefileType   => {
-        Name => 'DigitalSourceFileType',
-        Notes => 'now deprecated -- replaced by DigitalSourceType',
-    },
-    DigitalSourceType       => { Name => 'DigitalSourceType' },
-    Event                   => { Writable => 'lang-alt' },
-    RegistryId => {
-        Struct => {
-            STRUCT_NAME => 'RegistryEntryDetails',
-            NAMESPACE   => 'Iptc4xmpExt',
-            RegItemId    => { },
-            RegOrgId     => { },
-        },
-        List => 'Bag',
-    },
-    RegistryIdRegItemId         => { Flat => 1, Name => 'RegistryItemID' },
-    RegistryIdRegOrgId          => { Flat => 1, Name => 'RegistryOrganisationID' },
-    IptcLastEdited          => { Groups => { 2 => 'Time' }, %dateTimeInfo },
-    LocationCreated => {
-        Struct => \%sLocationDetails,
-        Groups => { 2 => 'Location' },
-        List => 'Bag',
-    },
-    MaxAvailHeight  => { Writable => 'integer' },
-    MaxAvailWidth   => { Writable => 'integer' },
-);
-
-# Adobe Lightroom schema properties (lr) (ref PH)
+    # Copyright - have seen this in a sample (Jan 2021), but I think it is non-standard
+);
+
+# Adobe Lightroom namespace properties (lr) (ref PH)
 %Image::ExifTool::XMP::Lightroom = (
     %xmpTableDefaults,
@@ -1979,10 +2343,10 @@
     NAMESPACE   => 'lr',
     TABLE_DESC => 'XMP Adobe Lightroom',
-    NOTES => 'Adobe Lightroom "lr" schema tags.',
+    NOTES => 'Adobe Lightroom "lr" namespace tags.',
     privateRTKInfo => { },
     hierarchicalSubject => { List => 'Bag' },
 );
 
-# Adobe Album schema properties (album) (ref PH)
+# Adobe Album namespace properties (album) (ref PH)
 %Image::ExifTool::XMP::Album = (
     %xmpTableDefaults,
@@ -1990,5 +2354,5 @@
     NAMESPACE   => 'album',
     TABLE_DESC => 'XMP Adobe Album',
-    NOTES => 'Adobe Album schema tags.',
+    NOTES => 'Adobe Album namespace tags.',
     Notes => { },
 );
@@ -2002,28 +2366,99 @@
 # Composite XMP tags
 %Image::ExifTool::XMP::Composite = (
-    # get latitude/logitude reference from XMP lat/long tags
+    # get latitude/longitude reference from XMP lat/long tags
     # (used to set EXIF GPS position from XMP tags)
     GPSLatitudeRef => {
-        Require => 'XMP:GPSLatitude',
+        Require => 'XMP-exif:GPSLatitude',
+        Groups => { 2 => 'Location' },
+        # Note: Do not Inihibit based on EXIF:GPSLatitudeRef (see forum10192)
         ValueConv => q{
             IsFloat($val[0]) and return $val[0] < 0 ? "S" : "N";
-            $val[0] =~ /.*([NS])/;
+            $val[0] =~ /^.*([NS])/;
             return $1;
         },
-        PrintConv => {
-            N => 'North',
-            S => 'South',
-        },
+        PrintConv => { N => 'North', S => 'South' },
     },
     GPSLongitudeRef => {
-        Require => 'XMP:GPSLongitude',
+        Require => 'XMP-exif:GPSLongitude',
+        Groups => { 2 => 'Location' },
         ValueConv => q{
             IsFloat($val[0]) and return $val[0] < 0 ? "W" : "E";
-            $val[0] =~ /.*([EW])/;
+            $val[0] =~ /^.*([EW])/;
             return $1;
         },
-        PrintConv => {
-            E => 'East',
-            W => 'West',
+        PrintConv => { E => 'East', W => 'West' },
+    },
+    GPSDestLatitudeRef => {
+        Require => 'XMP-exif:GPSDestLatitude',
+        Groups => { 2 => 'Location' },
+        ValueConv => q{
+            IsFloat($val[0]) and return $val[0] < 0 ? "S" : "N";
+            $val[0] =~ /^.*([NS])/;
+            return $1;
+        },
+        PrintConv => { N => 'North', S => 'South' },
+    },
+    GPSDestLongitudeRef => {
+        Require => 'XMP-exif:GPSDestLongitude',
+        Groups => { 2 => 'Location' },
+        ValueConv => q{
+            IsFloat($val[0]) and return $val[0] < 0 ? "W" : "E";
+            $val[0] =~ /^.*([EW])/;
+            return $1;
+        },
+        PrintConv => { E => 'East', W => 'West' },
+    },
+    LensID => {
+        Notes => 'attempt to convert numerical XMP-aux:LensID stored by Adobe applications',
+        Require => {
+            0 => 'XMP-aux:LensID',
+            1 => 'Make',
+        },
+        Desire => {
+            2 => 'LensInfo',
+            3 => 'FocalLength',
+            4 => 'LensModel',
+            5 => 'MaxApertureValue',
+        },
+        Inhibit => {
+            6 => 'Composite:LensID',    # don't override existing Composite:LensID
+        },
+        Groups => { 2 => 'Camera' },
+        ValueConv => '$val',
+        PrintConv => 'Image::ExifTool::XMP::PrintLensID($self, @val)',
+    },
+    Flash => {
+        Notes => 'facilitates copying camera flash information between XMP and EXIF',
+        Desire => {
+            0 => 'XMP:FlashFired',
+            1 => 'XMP:FlashReturn',
+            2 => 'XMP:FlashMode',
+            3 => 'XMP:FlashFunction',
+            4 => 'XMP:FlashRedEyeMode',
+            5 => 'XMP:Flash', # handle structured flash information too
+        },
+        Groups => { 2 => 'Camera' },
+        Writable => 1,
+        PrintHex => 1,
+        SeparateTable => 'EXIF Flash',
+        ValueConv => q{
+            if (ref $val[5] eq 'HASH') {
+                # copy structure fields into value array
+                my $i = 0;
+                $val[$i++] = $val[5]{$_} foreach qw(Fired Return Mode Function RedEyeMode);
+            }
+            return((($val[0] and lc($val[0]) eq 'true') ? 0x01 : 0) |
+                   (($val[1] || 0) << 1) |
+                   (($val[2] || 0) << 3) |
+                   (($val[3] and lc($val[3]) eq 'true') ? 0x20 : 0) |
+                   (($val[4] and lc($val[4]) eq 'true') ? 0x40 : 0));
+        },
+        PrintConv => \%Image::ExifTool::Exif::flash,
+        WriteAlso => {
+            'XMP:FlashFired'      => '$val & 0x01 ? "True" : "False"',
+            'XMP:FlashReturn'     => '($val & 0x06) >> 1',
+            'XMP:FlashMode'       => '($val & 0x18) >> 3',
+            'XMP:FlashFunction'   => '$val & 0x20 ? "True" : "False"',
+            'XMP:FlashRedEyeMode' => '$val & 0x40 ? "True" : "False"',
         },
     },
@@ -2057,11 +2492,12 @@
 # Inputs: 0) string to be unescaped
 #         1) optional hash reference to convert entity names to numbers
+#         2) optional character encoding
 # Returns: unescaped string
 my %charNum = ('quot'=>34, 'amp'=>38, 'apos'=>39, 'lt'=>60, 'gt'=>62);
-sub UnescapeXML($;$)
+sub UnescapeXML($;$$)
 {
-    my ($str, $conv) = @_;
+    my ($str, $conv, $enc) = @_;
     $conv = \%charNum unless $conv;
-    $str =~ s/&(#?\w+);/UnescapeChar($1,$conv)/sge;
+    $str =~ s/&(#?\w+);/UnescapeChar($1,$conv,$enc)/sge;
     return $str;
 }
@@ -2099,10 +2535,11 @@
 #------------------------------------------------------------------------------
 # Convert XML character reference to UTF-8
-# Inputs: 0) XML character reference stripped of the '&' and ';' (ie. 'quot', '#34', '#x22')
+# Inputs: 0) XML character reference stripped of the '&' and ';' (eg. 'quot', '#34', '#x22')
 #         1) hash reference for looking up character numbers by name
+#         2) optional character encoding (default 'UTF8')
 # Returns: UTF-8 equivalent (or original character on conversion error)
-sub UnescapeChar($$)
+sub UnescapeChar($$;$)
 {
-    my ($ch, $conv) = @_;
+    my ($ch, $conv, $enc) = @_;
     my $val = $$conv{$ch};
     unless (defined $val) {
@@ -2116,17 +2553,19 @@
     }
     return chr($val) if $val < 0x80;   # simple ASCII
-    return pack('C0U', $val) if $] >= 5.006001;
-    return Image::ExifTool::PackUTF8($val);
+    $val = $] >= 5.006001 ? pack('C0U', $val) : Image::ExifTool::PackUTF8($val);
+    $val = Image::ExifTool::Decode(undef, $val, 'UTF8', undef, $enc) if $enc and $enc ne 'UTF8';
+    return $val;
 }
 
 #------------------------------------------------------------------------------
 # Does a string contain valid UTF-8 characters?
-# Inputs: 0) string reference
+# Inputs: 0) string reference, 1) true to allow last character to be truncated
 # Returns: 0=regular ASCII, -1=invalid UTF-8, 1=valid UTF-8 with maximum 16-bit
 #          wide characters, 2=valid UTF-8 requiring 32-bit wide characters
 # Notes: Changes current string position
-sub IsUTF8($)
+# (see http://www.fileformat.info/info/unicode/utf8.htm for help understanding this)
+sub IsUTF8($;$)
 {
-    my $strPt = shift;
+    my ($strPt, $trunc) = @_;
     pos($$strPt) = 0; # start at beginning of string
     return 0 unless $$strPt =~ /([\x80-\xff])/g;
@@ -2150,5 +2589,19 @@
             $rtnVal = 2;
         }
-        return -1 unless $$strPt =~ /\G[\x80-\xbf]{$n}/g;
+        my $pos = pos $$strPt;
+        unless ($$strPt =~ /\G([\x80-\xbf]{$n})/g) {
+            return $rtnVal if $trunc and $pos + $n > length $$strPt;
+            return -1;
+        }
+        # the following is ref https://www.cl.cam.ac.uk/%7Emgk25/ucs/utf8_check.c
+        if ($n == 2) {
+            return -1 if ($ch == 0xe0 and (ord($1) & 0xe0) == 0x80) or
+                         ($ch == 0xed and (ord($1) & 0xe0) == 0xa0) or
+                         ($ch == 0xef and ord($1) == 0xbf and
+                            (ord(substr $1, 1) & 0xfe) == 0xbe);
+        } else {
+            return -1 if ($ch == 0xf0 and (ord($1) & 0xf0) == 0x80) or
+                         ($ch == 0xf4 and ord($1) > 0x8f) or $ch > 0xf4;
+        }
         last unless $$strPt =~ /([\x80-\xff])/g;
     }
@@ -2157,10 +2610,11 @@
 
 #------------------------------------------------------------------------------
-# Fix malformed UTF8 (by replacing bad bytes with '?')
-# Inputs: 0) string reference
+# Fix malformed UTF8 (by replacing bad bytes with specified character)
+# Inputs: 0) string reference, 1) string to replace each bad byte,
+#         may be '' to delete bad bytes, or undef to use '?'
 # Returns: true if string was fixed, and updates string
-sub FixUTF8($)
+sub FixUTF8($;$)
 {
-    my $strPt = shift;
+    my ($strPt, $bad) = @_;
     my $fixed;
     pos($$strPt) = 0; # start at beginning of string
@@ -2172,9 +2626,22 @@
         if ($ch >= 0xc2 and $ch < 0xf8) {
             my $n = $ch < 0xe0 ? 1 : ($ch < 0xf0 ? 2 : 3);
-            next if $$strPt =~ /\G[\x80-\xbf]{$n}/g;
-        }
-        # replace bad character with '?'
-        substr($$strPt, $pos-1, 1) = '?';
-        pos($$strPt) = $fixed = $pos;
+            if ($$strPt =~ /\G([\x80-\xbf]{$n})/g) {
+                next if $n == 1;
+                if ($n == 2) {
+                    next unless ($ch == 0xe0 and (ord($1) & 0xe0) == 0x80) or
+                                ($ch == 0xed and (ord($1) & 0xe0) == 0xa0) or
+                                ($ch == 0xef and ord($1) == 0xbf and
+                                    (ord(substr $1, 1) & 0xfe) == 0xbe);
+                } else {
+                    next unless ($ch == 0xf0 and (ord($1) & 0xf0) == 0x80) or
+                                ($ch == 0xf4 and ord($1) > 0x8f) or $ch > 0xf4;
+                }
+            }
+        }
+        # replace bad character
+        $bad = '?' unless defined $bad;
+        substr($$strPt, $pos-1, 1) = $bad;
+        pos($$strPt) = $pos-1 + length $bad;
+        $fixed = 1;
     }
     return $fixed;
@@ -2218,5 +2685,5 @@
 
 #------------------------------------------------------------------------------
-# Generate a name for this XMP tag
+# Generate a tag ID for this XMP tag
 # Inputs: 0) tag property name list ref, 1) array ref for receiving structure property list
 #         2) array for receiving namespace list
@@ -2230,6 +2697,7 @@
         # (Note: namespace can be '' for property qualifiers)
         my ($ns, $nm) = ($prop =~ /(.*?):(.*)/) ? ($1, $2) : ('', $prop);
-        if ($ignoreNamespace{$ns}) {
+        if ($ignoreNamespace{$ns} or $ignoreProp{$prop}) {
             # special case: don't ignore rdf numbered items
+            # (not technically allowed in XMP, but used in RDF/XML)
             unless ($prop =~ /^rdf:(_\d+)$/) {
                 # save list index if necessary for structures
@@ -2244,11 +2712,11 @@
             # all uppercase is ugly, so convert it
             if ($nm !~ /[a-z]/) {
-                my $xlatNS = $$xlatNamespace{$ns} || $ns;
-                my $info = $Image::ExifTool::XMP::Main{$xlatNS};
+                my $xlat = $stdXlatNS{$ns} || $ns;
+                my $info = $Image::ExifTool::XMP::Main{$xlat};
                 my $table;
-                if (ref $info eq 'HASH' and $info->{SubDirectory}) {
-                    $table = GetTagTable($info->{SubDirectory}{TagTable});
+                if (ref $info eq 'HASH' and $$info{SubDirectory}) {
+                    $table = GetTagTable($$info{SubDirectory}{TagTable});
                 }
-                unless ($table and $table->{$nm}) {
+                unless ($table and $$table{$nm}) {
                     $nm = lc($nm);
                     $nm =~ s/_([a-z])/\u$1/g;
@@ -2278,5 +2746,5 @@
 #------------------------------------------------------------------------------
 # Register namespace for specified user-defined table
-# Inputs: 0) tag or structure table ref
+# Inputs: 0) tag/structure table ref
 # Returns: namespace prefix
 sub RegisterNamespace($)
@@ -2290,4 +2758,5 @@
         $ns = $$nsRef[0];
         $nsURI{$ns} = $$nsRef[1];
+        $uri2ns{$$nsRef[1]} = $ns;
     } else { # must be a hash
         my @ns = sort keys %$nsRef; # allow multiple namespace definitions
@@ -2295,7 +2764,8 @@
             $ns = pop @ns;
             if ($nsURI{$ns} and $nsURI{$ns} ne $$nsRef{$ns}) {
-                warn "User-defined namespace prefix '$ns' conflicts with existing namespace\n";
+                warn "User-defined namespace prefix '${ns}' conflicts with existing namespace\n";
             }
             $nsURI{$ns} = $$nsRef{$ns};
+            $uri2ns{$$nsRef{$ns}} = $ns;
         }
     }
